/* (C) 2009-2011,2016 Yana */

#if !defined(YK0B_INTERNAL_H)
#define YK0B_INTERNAL_H

#define YK0B_CONTEXT_BASE 8
#define YK0B_CONTEXT_SIZE 32

#define YK0B_STATE_READY 0
#define YK0B_STATE_RECEIVE 1
#define YK0B_STATE_REPLY 2
#define YK0B_STATE_SEND 3

#define YK0B_MIPS_STATUS $12
#define YK0B_MIPS_CAUSE $13
#define YK0B_MIPS_EPC $14

#define YK0B_MIPS_HAZARD_STATUS
#define YK0B_MIPS_HAZARD_CAUSE
#define YK0B_MIPS_HAZARD_EPC

#define YK0B_MIPS_STATUS_IM_MASK (0xff << YK0B_MIPS_STATUS_IM_SHIFT)
#define YK0B_MIPS_STATUS_IM_SHIFT 8
#define YK0B_MIPS_STATUS_KSU_MASK (3 << YK0B_MIPS_STATUS_KSU_SHIFT)
#define YK0B_MIPS_STATUS_KSU_SHIFT 3
#define YK0B_MIPS_STATUS_ERL (1 << 2)
#define YK0B_MIPS_STATUS_EXL (1 << 1)
#define YK0B_MIPS_STATUS_IE (1 << 0)

#define YK0B_MIPS_CAUSE_BD (1 << 31)
#define YK0B_MIPS_CAUSE_IP_MASK (0xff << YK0B_MIPS_CAUSE_IP_SHIFT)
#define YK0B_MIPS_CAUSE_IP_SHIFT 8
#define YK0B_MIPS_CAUSE_EXCCODE_MASK (0x1f << YK0B_MIPS_CAUSE_EXCCODE_SHIFT)
#define YK0B_MIPS_CAUSE_EXCCODE_SHIFT 2

#define YK0B_MIPS_CAUSE_EXCCODE_INT (0x00 << YK0B_MIPS_CAUSE_EXCCODE_SHIFT)
#define YK0B_MIPS_CAUSE_EXCCODE_SYS (0x08 << YK0B_MIPS_CAUSE_EXCCODE_SHIFT)

#endif
