/* (C) 2009-2011,2016 Yana */

#if !defined(Y_YK0B_H)
#define Y_YK0B_H

#if !defined(Y_PREPROCESS_ONLY)

#include "yk0b.h"
#include <stddef.h>

#if !defined(__GNUC__)
#define __inline__
#endif

__inline__ static void y_yk0b_start(yk0b_task_t task, void (*pc)(void), void *sp, void *gp, yk0b_context_value_t status) {
	yk0b_set_context(task, YK0B_CONTEXT_EPC, (yk0b_context_value_t)pc, NULL);
	yk0b_set_context(task, YK0B_CONTEXT_GPR28, (yk0b_context_value_t)gp, NULL);
	yk0b_set_context(task, YK0B_CONTEXT_GPR29, (yk0b_context_value_t)sp, NULL);
	yk0b_set_context(task, YK0B_CONTEXT_GPR31, (yk0b_context_value_t)pc, NULL);
	yk0b_set_context(task, YK0B_CONTEXT_STATUS, status, NULL);
	yk0b_set_context(task, YK0B_CONTEXT_CAUSE, 0, NULL);
	yk0b_reply(task);
}

#endif

#endif
