/* (C) 2009-2011,2016 Yana */

#define Y_PREPROCESS_ONLY
#include "start_setup.h"
#include "yanamips.h"

#define CAUSE_OFF 0
#define CAUSE_ON 0
#define STATUS_OFF YANAMIPS_STATUS_IE
#define STATUS_ON YANAMIPS_STATUS_EXL

#if !defined(__GNUC__)

	.global task0_stack
	.comm task0_stack, TASK0_STACK_SIZE, Y_STACK_ALIGNMENT

	.global task1_stack
	.comm task1_stack, TASK1_STACK_SIZE, Y_STACK_ALIGNMENT

#endif

	.text
	.balign 4
	.set at
	.set reorder

	.global start
start:
	mfc0 $2, YANAMIPS_CAUSE
	li $3, ~CAUSE_OFF
	and $2, $2, $3
	li $3, CAUSE_ON
	or $2, $2, $3
	mtc0 $2, YANAMIPS_CAUSE
	YANAMIPS_HAZARD_CAUSE

	mfc0 $2, YANAMIPS_STATUS
	li $3, ~STATUS_OFF
	and $2, $2, $3
	li $3, STATUS_ON
	or $2, $2, $3
	mtc0 $2, YANAMIPS_STATUS
	YANAMIPS_HAZARD_STATUS

	la $gp, _gp
	la $sp, START_SETUP_TASK0_SP
	la $ra, START_SETUP_TASK0_PC
	mtc0 $ra, YANAMIPS_EPC
	YANAMIPS_HAZARD_EPC
	.word 0x42000018 /* eret */
